using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Ziegenproblem
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private int numRounds;
        private int firstGuessWins;
        private int secondGuessWins;

        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);
            if (numRounds > 0)
            {
                double firstGuessWinsProb = firstGuessWins / (double)numRounds;
                double secondGuessWinsProb = secondGuessWins / (double)numRounds;
                e.Graphics.FillRectangle(Brushes.Violet, panel1.Location.X, panel1.Location.Y, (int)(panel1.Size.Width * firstGuessWinsProb), panel1.Size.Height / 2 - 5);
                e.Graphics.FillRectangle(Brushes.Cyan, panel1.Location.X, panel1.Location.Y + panel1.Size.Height / 2 + 5, (int)(panel1.Size.Width * secondGuessWinsProb), panel1.Size.Height / 2 - 5);
                Font f = new Font("Verdana", 9.0f);
                e.Graphics.DrawString("First Guess: " + (firstGuessWinsProb * 100.0).ToString("F1") + "%", f, Brushes.Black, panel1.Location.X + 10, panel1.Location.Y + 10);
                e.Graphics.DrawString("Second Guess: " + (secondGuessWinsProb * 100.0).ToString("F1") + "%", f, Brushes.Black, panel1.Location.X + 10, panel1.Location.Y + 10 + panel1.Size.Height / 2 + 5);
            }
        }

        private Random r = new Random();

        private void playOneRound()
        {
            numRounds++;
            int carBehindDoor = r.Next(3);
            int firstGuess = r.Next(3);
            int showmasterOpensDoor = -1;
            if (carBehindDoor == firstGuess)
            {
                firstGuessWins++;
                showmasterOpensDoor = (carBehindDoor + r.Next(2) + 1) % 3;
            }
            else
            {
                showmasterOpensDoor = 3 - carBehindDoor - firstGuess;
            }
            int secondGuess = 3 - showmasterOpensDoor - firstGuess;
            if (secondGuess == carBehindDoor)
            {
                secondGuessWins++;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            int rounds = Int32.Parse(((Button)sender).Text);
            for (int i = 0; i < rounds; i++)
            {
                playOneRound();
            }
            Invalidate();
        }
    }
}